#!/bin/sh

case "$1" in
  /*) left="${1#/}";;
  *) left="${PWD#/}/$1";;
esac

result=""

while [ -n "$left" ]; do
  case "$left" in
  */*)
    seg="${left%%/*}"
    left="${left#*/}"
    ;;
  *)
    seg="$left"
    left=""
    ;;
  esac
  case "$seg" in
  .)
    result="${result%/*}"
    continue
    ;;
  ..)
    result="${result%/*/*}"
    continue
    ;;
  esac
  result="$result/$seg"
  target="$(readlink "$result")"
  case "$target" in
    /*) left="${target}"
        result="";;
    '') ;;
    *) left="${left%/*}/${target}";;
  esac
  left="${left#/}"
done

echo "$result"
